/*
    réception d’une valeur integer via module nRF24L01
 */
#include <MirfSpiDriver.h>
#include <SPI.h> // gestion du bus SPI
#include <Mirf.h> // gestion de la communication
#include <nRF24L01.h> // définition des registres du nRF24L01
#include <MirfHardwareSpiDriver.h> // communication SPI nRF24L01


int valeur = 0;  // contient la valeur à recevoir
byte valeur_octet[2]; // contient la valeur découpée en octet pour la réception
char buffer[32]="STOP_,0110,0110";// incomming frame memory
char verif[15];
String verifstr;
char sens[6];// message from the emitter: FWLFT,FWRGT,FW___,STOP,RVLFT,RVRGT,RV___
String sensdemarche;
char consigne1[5];// first SP of speed from trimer 0 to 1023
String consigne1str;
int valconsigne1;
char consigne2[5];// second SP of speed from trimmer 0 to 1023
String consigne2str;
int valconsigne2;
const int DCmotorLEFT = 5;      // the number of the MOTOR pin
const int DCmotorRGHT = 6;      // the number of the MOTOR pin
int flag=0;//flag to check if still linked to emitter
int sample1;//sample used with flag
int sample2;

void setup()
{
  pinMode(2,OUTPUT);
  Serial.begin(9600);//for external debugger on RX and TX with USB/RS232 TTL converter
  Mirf.cePin = 8; // CE sur broche 8
  Mirf.csnPin = 7; // CSN sur broche 7
  Mirf.spi = &MirfHardwareSpi; // utilisation du port SPI hardware
  Mirf.init(); // initialise le module SPI
  Mirf.channel = 120; // utilisation canal 0 pour communiquer (128 canaux disponible, de 0 à 127)
  // RF_SETUP=0000abcd : a=1–>2Mb/s, a=0–>1Mb/s; puissance émission bc=00–>-18 dBm, bc=01–>-12dBm, bc=10–>-6dBm, bc=11–>0dBm;
  // d=0 pas de gain sur le bruit en réception
  Mirf.configRegister(RF_SETUP, 0x06); // 1 Mb/s et 0 dBm (puissance maximum)
  Mirf.setTADDR((byte *)"clien"); // définition adresse sur 5 octets de la 2ème carte Arduino
  Mirf.setRADDR((byte *)"serve"); // définition adresse sur 5 octets de la 1ere carte Arduino
  Mirf.payload = 32; // = 2, déclaration taille du message à transmettre, max 32 octets
  //Mirf.configRegister(EN_AA,0x00);  //Disable auto ack
  Mirf.config(); // configure le canal et la taille du message
  delay(100);
  TCCR0B = TCCR0B & 0b11111000 | 0x01;//timer 0 for pin 5 & 6 to modify PWM frequency, 8 for
  //8khz; 1 for 64 khz, !!!it affects millis and delay functions: faster
}

void loop()
{
  sample1=flag;
  
  //****************************************************************************
  //Checking good work of the emitter: if emitter under suplied or OFF, it stops the boat***  
   if (!Mirf.dataReady())
  {    // READY TO GET DATAS
    flag=flag+2;
    if ((sample1-sample2)<=40){
      Serial.println("RUN");
       if (flag>=1000){
        flag=100;}
    }
    //Serial.println("DEBUT");
    if ((sample1-sample2)>100){
     if (flag>=1000){
        flag=100;sample1=101;sample2=0;}
      Serial.println("STOP");
      //Serial.println(flag);
      analogWrite(DCmotorLEFT, 110);
      analogWrite(DCmotorRGHT, 110);
    }
    delay(5);
  }

  //****************************************************************************
  //Reading the frame   STOP_,1234,1234  ***************************************
  byte data[32]; // or int data[32]

    if(!Mirf.isSending() && Mirf.dataReady()){
    //Serial.println("Got packet");
    flag=flag-2;
    sample2=flag;
    int i=0;
    Mirf.getData((byte *) &data);
    for (i=0;i<20;i++)
    {
      buffer[i] = (char)data[i];
      //Serial.print(buffer[i]);
    }

    int v=0;
    for (v=0;v<15;v++)
    {
      verif[v]=buffer[v];//en char
      verifstr=verif;//char en string
      if (verifstr[5]!=',' | verifstr[10]!=','){
        //Serial.println("problem");
        char buffer[]="STOP_,0524,0503";
        analogWrite(DCmotorLEFT, 110);
        analogWrite(DCmotorRGHT, 110);
      }
    }
    //Serial.println(buffer);
    //**************************************************************************
    //Controlling bytes 0 to 4 of the frame: message ***************************
    int j=0;
    for (j=0;j<5;j++)
    {
      sens[j]=buffer[j];//en char
      sensdemarche=sens;//char en string
      //Serial.println(sensdemarche);

    }
    //***************************************************************************
    //Controlling bytes 6 to 9 of the frame: free to use *********************
    int k=6;
    for (k=6;k<10;k++)
    {
      consigne1[k-6]=buffer[k];//en char
      consigne1str=consigne1;//en string
      valconsigne1=atoi(consigne1);//char en string
      //Serial.println(valconsigne1);
    }
    //***************************************************************************
    //Controlling bytes 11 to 14 of the frame: speed  **************************
    int m=11;
    for (m=11;m<15;m++)
    {
      consigne2[m-11]=buffer[m];//en char
      consigne2str=consigne2;//en string
      valconsigne2=atoi(consigne2);//string en integer
      if (valconsigne2<9) {
        valconsigne2=9;
      }
      if (valconsigne2>920) {
        valconsigne2=920;
      }
      //Serial.println(valconsigne2/4.04);
    }
    //***************************************************************************
    //Reading the messages and and the speed set point  **************************

    if(sensdemarche=="FW___" | sensdemarche=="RV___"){   // comparaison sur string 
      analogWrite(DCmotorLEFT, valconsigne2/4.04);
      analogWrite(DCmotorRGHT, valconsigne2/4.04);
      Serial.println("FW");
    }
    digitalWrite(2,LOW);
    if(sensdemarche=="STOP_"){   // comparaison sur string 
      analogWrite(DCmotorLEFT, 110);
      analogWrite(DCmotorRGHT, 110);
      flag=flag+1;
      sample2=flag;
    }
    if(sensdemarche=="RVLFT"){   // comparaison sur string 
      analogWrite(DCmotorRGHT, valconsigne2/4.04);
      analogWrite(DCmotorLEFT, 110);
      Serial.println("rvlft");
    }
    if(sensdemarche=="RVRGT"){   // comparaison sur string 
      analogWrite(DCmotorLEFT, valconsigne2/4.04);
      analogWrite(DCmotorRGHT, 110);
      Serial.println("rvrgt");
    }
    if(sensdemarche=="FWLFT"){   // comparaison sur string 
      analogWrite(DCmotorRGHT, valconsigne2/4.04);
      analogWrite(DCmotorLEFT, 110);
      Serial.println("FWlft");
    }
    if(sensdemarche=="FWRGT"){   // comparaison sur string 
      analogWrite(DCmotorLEFT, valconsigne2/4.04);
      analogWrite(DCmotorRGHT, 110);
      Serial.println("FWrgt");
    }
    delay(70);
  }
  else {    
  }
}





















